/*****************************************************************************

 Module:       newoutput.cpp
 Author:       Christian Mayer
 Date started: 28.05.99
 Called by:    main program

 ---------- Copyright (C) 1999  Christian Mayer (vader@t-online.de) ----------

 This program is free software; you can redistribute it and/or modify it under
 the terms of the GNU General Public License as published by the Free Software
 Foundation; either version 2 of the License, or (at your option) any later
 version.

 This program is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 details.

 You should have received a copy of the GNU General Public License along with
 this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 Place - Suite 330, Boston, MA  02111-1307, USA.

 Further information about the GNU General Public License can also be found on
 the world wide web at http://www.gnu.org.

FUNCTIONAL DESCRIPTION
------------------------------------------------------------------------------
library for Voronoi Diagram calculation
based on Steven Fortune 'Sweep2'

HISTORY
------------------------------------------------------------------------------
30.05.99   Christian Mayer	Created
16.06.99   Durk Talsma		Portability for Linux
*****************************************************************************/

#include "defs.h"
#include "voronoi.h"
#include <iostream>

cellList cl;

extern "C" {

void out_ep(struct Edge *e)
{	
    PointList pl;
    
    //is the new line actually only a point?
    if ( (e->ep[le] != (struct Site *)NULL)&&(e->ep[re] != (struct Site *)NULL) )
	if ((ABS(e->ep[re]->coord.x - e->ep[le]->coord.x)<0.00001)&&
	    (ABS(e->ep[re]->coord.y - e->ep[le]->coord.y)<0.00001))
	    return;
	
    //increase cl if necessary
    while ((e->reg[le]->sitenbr + 1)>cl.size())
	cl.push_back(cell(cl.size(),pl));
    
    //increase cl if necessary
    while ((e->reg[re]->sitenbr + 1)>cl.size())
	cl.push_back(cell(cl.size(),pl));

    //store left
    if (e->ep[le] != (struct Site *)NULL)
	cl[e->reg[le]->sitenbr].boundary.push_back(VoronoiPoint(e->ep[le]->coord.x, e->ep[le]->coord.y));
    else
	cl[e->reg[le]->sitenbr].boundary.push_back(VoronoiPoint(e->b, -e->a, true));   //store direction vector at least
    
    if (e->ep[re] != (struct Site *)NULL)
	cl[e->reg[le]->sitenbr].boundary.push_back(VoronoiPoint(e->ep[re]->coord.x, e->ep[re]->coord.y));
    else
	cl[e->reg[le]->sitenbr].boundary.push_back(VoronoiPoint(e->b, -e->a, true));   //store direction vector at least
    
    //store right (do everything inverted to get the same orientation of the line
    if (e->ep[re] != (struct Site *)NULL)
	cl[e->reg[re]->sitenbr].boundary.push_back(VoronoiPoint(e->ep[re]->coord.x, e->ep[re]->coord.y));
    else
	cl[e->reg[re]->sitenbr].boundary.push_back(VoronoiPoint(e->b, -e->a, true));   //store direction vector at least
    
    if (e->ep[le] != (struct Site *)NULL)
	cl[e->reg[re]->sitenbr].boundary.push_back(VoronoiPoint(e->ep[le]->coord.x, e->ep[le]->coord.y));
    else
	cl[e->reg[re]->sitenbr].boundary.push_back(VoronoiPoint(e->b, -e->a, true));   //store direction vector at least
}

} //extern "C"








